<!doctype html>
<html lang="es">

<head>
  <meta charset='utf-8'>
  <title>Introducción a Formularios</title>
  <link rel='stylesheet' href='css/style.css'>
  <link rel='stylesheet' href='css/print.css' media='print'>
</head>

<body>


  <article class='reveal'>

    <section data-bespoke-state='portada'>
      <h1>Introducción a Formularios</h1>
    </section>

    <section data-bespoke-state='clean'>
      <h2><span class="etiqueta">form</span></h2>
      <ul class="lista">
        <li>Agrupa todas las etiquetas que recogen datos</li>
        <li>Envía los datos a donde se indique</li>
        <li>Propiedades:
          <ul>
            <li><span class="propiedad">method</span>, método <strong>HTTP</strong> utilizado:
              <ul>
                <li><span class="valor">GET</span>, para obtener información (va en la url)</li>
                <li><span class="valor">POST</span>, para guardar información</li>
              </ul>
            </li>
            <li><span class="propiedad">action</span>, url a la que enviar los datos</li>
          </ul>
        </li>
      </ul>
      <h3>Ejemplo</h3>
      <pre><code><span class="etiqueta">form <span class="propiedad">method=</span><span class="valor">"GET"</span> <span class="propiedad">action=</span><span class="valor">"http://url.es"</span></span>
  ...
<span class="etiqueta">/form</span></code></pre>
    </section>

    <section data-bespoke-state='clean'>
      <h2>Propiedades comunes</h2>
      <ul class="lista">
        <li><span class="propiedad">name</span>, nombre del control</li>
        <li><span class="propiedad">value</span>, valor del control</li>
        <li><span class="propiedad">required</span>, si es obligatorio (no se asigna valor)</li>
        <li><span class="propiedad">placeholder</span>, texto que aparece en algunos controles</li>
      </ul>
      <h3>Ejemplo</h3>
      <pre><code><span class="etiqueta">textarea <span class="propiedad">name=</span><span class="valor">"comentario"</span> <span class="propiedad">placeholder=</span><span class="valor">"Escribe cualquier comentario"</span></span><span class="etiqueta">/textarea</span></code></pre>
      <div>
        <label class="importante" for="comentario">Comentarios: </label>
        <textarea id="comentario" name="comentario" placeholder="Escribe cualquier comentario" rows="6" cols="60"></textarea>
      </div>
    </section>

    <section class="pt-2" data-bespoke-state='clean'>
      <h2><span class="etiqueta">input <span class="propiedad">type=</span><span class="valor">"valor"</span></span></h2>
      <ul class="lista">
        <li>Diferentes según la propiedad <span class="propiedad">type</span>:
          <ul>
            <li><span class="valor">text</span>, caja de texto</li>
            <li><span class="valor">password</span>, caja de contraseña</li>
            <li><span class="valor">email</span>, caja de email</li>
            <li><span class="valor">number</span>, caja de números</li>
            <li><span class="valor">date</span>, caja de fecha</li>
            <li><span class="valor">checkbox</span>, casilla de verificación</li>
            <li><span class="valor">radio</span>, casilla de opción única (agrupadas por <span class="propiedad">name</span>)</li>

          </ul>
        </li>
      </ul>
    </section>

    <section data-bespoke-state='clean'>
      <h2>Ejemplos</h2>
      <div class="columnas-flex">
        <pre><code><span class="etiqueta">input <span class="propiedad">type=</span><span class="valor">"text"</span></span>
<span class="etiqueta">input <span class="propiedad">type=</span><span class="valor">"password"</span></span>
<span class="etiqueta">input <span class="propiedad">type=</span><span class="valor">"number"</span></span>
<span class="etiqueta">input <span class="propiedad">type=</span><span class="valor">"email"</span></span>
<span class="etiqueta">input <span class="propiedad">type=</span><span class="valor">"date"</span></span>
<span class="etiqueta">input <span class="propiedad">type=</span><span class="valor">"checkbox"</span></span>
<span class="etiqueta">input <span class="propiedad">type=</span><span class="valor">"radio"</span></span></code></pre>
        <div style="line-height: 2em; text-align: left;">
          <label>Text:</label> <input type="text"><br>
          <label>Password:</label> <input type="password"><br>
          <label>Email:</label> <input type="email"><br>
          <label>Number:</label> <input type="number"><br>
          <label>Date:</label> <input type="date"><br>
          <label>Checkbox:</label> <input type="checkbox"><br>
          <label>Radio:</label> <input type="radio" name="radio"> <input type="radio" name="radio">
        </div>
      </div>
    </section>

    <section data-bespoke-state='clean'>
      <h2>Botones</h2>
      <ul class="lista">
        <li>Etiqueta <span class="etiqueta">button</span>texto<span class="etiqueta">/button</span></li>
        <li>Permite definir el tipo con <span class="etiqueta">type</span>:
          <ul>
            <li><span class="valor">submit</span>, envía el formulario</li>
            <li><span class="valor">reset</span>, resetea el formulario</li>
          </ul>
        </li>
      </ul>
      <h3>Ejemplos</h3>
      <div class="columnas-flex">
        <pre class="columna-doble"><code><span class="etiqueta">button <span class="propiedad">type=</span><span class="valor">"submit"</span></span>Enviar<span class="etiqueta">/button</span>
<span class="etiqueta">button <span class="propiedad">type=</span><span class="valor">"reset"</span></span>Resetear<span class="etiqueta">/button</span></code></pre>
        <div style="line-height: 2em; text-align: left;">
          <button type="submit" style="border: 1px solid; border-radius: 5px; padding: .2em;">Enviar</button><br>
          <button type="reset" style="border: 1px solid; border-radius: 5px; padding: .2em;">Resetear</button><br>
        </div>
      </div>
    </section>

    <section class="no-print pt-2" data-bespoke-state='clean'>
      <h2>Ejercicio</h2>
      <ul class="lista">
        <li>Crear el siguiente formulario:</li>
      </ul>
      <p class="text-center">
        <img src="https://gitlab.com/Material_Formacion/html-y-css/ejercicios/-/raw/master/ejercicio25/img/resultado.png?inline=false">
      </p>
    </section>

    <section data-bespoke-state='clean'>
      <h2><span class="etiqueta">textarea</span></h2>
      <ul class="lista">
        <li>Área de texto, texto con varias filas</li>
        <li>Se puede modificar su tamaño</li>
        <li>Propiedades:
          <ul>
            <li><span class="propiedad">rows</span>, número de lineas inicial</li>
            <li><span class="propiedad">cols</span>, número de columnas inicial</li>
          </ul>
        </li>
      </ul>
      <h3>Ejemplo</h3>
      <pre><code><span class="etiqueta">textarea <span class="propiedad">name=</span><span class="valor">"comentario"</span> <span class="propiedad">rows=</span><span class="valor">"6"</span> <span class="propiedad">cols=</span><span class="valor">"60"</span> 
  <span class="propiedad">placeholder=</span><span class="valor">"Escribe cualquier comentario"</span></span><span class="etiqueta">/textarea</span></code></pre>
      <div>
        <label class="importante" for="comentario">Comentarios: </label>
        <textarea id="comentario" name="comentario" placeholder="Escribe cualquier comentario" rows="6" cols="60"></textarea>
      </div>
    </section>

    <section data-bespoke-state='clean'>
      <h2><span class="etiqueta">select</span>...<span class="etiqueta">/select</span></h2>
      <ul class="lista">
        <li>Lista seleccionable entre las opciones</li>
        <li>Propiedad opcinal <span class="propiedad">multiple</span> (sin valor)</li>
      </ul>
      <h3><span class="etiqueta">option</span>Texto<span class="etiqueta">/option</span></h3>
      <ul class="lista">
        <li>Va en los ... de <span class="etiqueta">select</span></li>
        <li>Propiedades:
          <ul>
            <li><span class="propiedad">value</span></li>
            <li><span class="propiedad">selected</span> (sin valor)</li>
          </ul>
        </li>
      </ul>
    </section>

    <section data-bespoke-state='clean'>
      <h2>Ejemplos</h2>
      <h3>Simple</h3>
      <div class="columnas-flex">
        <pre class="columna-doble"><code><span class="etiqueta">select <span class="propiedad">name=</span><span class="valor">"valoracion"</span></span>
  <span class="etiqueta">option <span class="propiedad">value=</span><span class="valor">""</span> <span class="propiedad">selected</span></span><span class="etiqueta">/option</span>
  <span class="etiqueta">option <span class="propiedad">value=</span><span class="valor">"0"</span></span>Malo<span class="etiqueta">/option</span>
  <span class="etiqueta">option <span class="propiedad">value=</span><span class="valor">"1"</span> </span>Normal<span class="etiqueta">/option</span>
  <span class="etiqueta">option <span class="propiedad">value=</span><span class="valor">"2"</span></span>Bueno<span class="etiqueta">/option</span>
  <span class="etiqueta">option <span class="propiedad">value=</span><span class="valor">"3"</span></span>Muy Bueno<span class="etiqueta">/option</span>
<span class="etiqueta">/select</span></code></pre>
        <div style="line-height: 2em; text-align: left;">
          <select name="valoracion" style="border: 1px solid; padding: .5em;">
            <option value="" selected></option>
            <option value="0">Malo</option>
            <option value="1">Normal</option>
            <option value="2">Bueno</option>
            <option value="3">Muy Bueno</option>
          </select>
        </div>
      </div>
      <h3>Múltiple</h3>
      <div class="columnas-flex">
        <pre class="columna-doble"><code><span class="etiqueta">select <span class="propiedad">name=</span><span class="valor">"colores"</span> <span class="propiedad">multiple</span></span>
  <span class="etiqueta">option <span class="propiedad">value=</span><span class="valor">"rojo"</span></span>Rojo<span class="etiqueta">/option</span>
  <span class="etiqueta">option <span class="propiedad">value=</span><span class="valor">"verde"</span></span>Verde<span class="etiqueta">/option</span>
  <span class="etiqueta">option <span class="propiedad">value=</span><span class="valor">"azul"</span><span class="propiedad">selected</span></span>Azul<span class="etiqueta">/option</span>
  <span class="etiqueta">option <span class="propiedad">value=</span><span class="valor">"negro"</span></span>Negro<span class="etiqueta">/option</span>
<span class="etiqueta">/select</span></code></pre>
        <div style="line-height: 2em; text-align: left;">
          <select name="valoracion" multiple style="border: 1px solid; padding: .5em;">
            <option value="rojo">Rojo</option>
            <option value="verde">Verde</option>
            <option value="azul" selected>Azul</option>
            <option value="negro">Negro</option>
          </select>
        </div>
      </div>      
    </section>

    <section data-bespoke-state='clean'>
      <h2>Ayudas visuales</h2>
      <ul class="lista">
        <li><span class="etiqueta">fieldset</span>...<span class="etiqueta">/fieldset</span>, contenedor con linea que agrupa controles</li>
        <li><span class="etiqueta">legend</span>Texto<span class="etiqueta">/legend</span>, texto que sale en el <span class="etiqueta">fieldset</span></li>
        <li><span class="etiqueta">label</span>Texto<span class="etiqueta">/label</span>, texto relacionado con un control
          <ul>
            <li><span class="propiedad">for</span>, asocia al control (por id)</li>
          </ul>
        </li>
      </ul>
      <h3>Ejemplo</h3>
      <div class="columnas-flex">
        <pre class="columna-doble"><code><span class="etiqueta">fieldset</span>
  <span class="etiqueta">legend</span>Dirección<span class="etiqueta">/legend</span>
  <span class="etiqueta">label <span class="propiedad">for=</span><span class="valor">"direccion"</span></span>Dirección:<span class="etiqueta">/label</span>
  <span class="etiqueta">input <span class="propiedad">type=</span><span class="valor">"text"</span> <span class="propiedad">id=</span><span class="valor">"direccion"</span></span>
  <span class="etiqueta">label <span class="propiedad">for=</span><span class="valor">"cp"</span></span>Código Postal:<span class="etiqueta">/label</span>
  <span class="etiqueta">input <span class="propiedad">type=</span><span class="valor">"text"</span> <span class="propiedad">id=</span><span class="valor">"cp"</span></span>
<span class="etiqueta">/fieldset</span></code></pre>
        <div style="line-height: 2em; text-align: left;">
          <fieldset style="border: 2px solid; padding: .5em;">
            <legend>Dirección</legend>
            <label for="direccion">Dirección:</label>
            <input type="text" id="direccion">
            <label for="cp">Código Postal:</label>
            <input type="text" id="cp">
          </fieldset>
        </div>
      </div> 
    </section>

    <section class="no-print pt-2" data-bespoke-state='clean'>
      <h2>Ejercicio</h2>
      <ul class="lista">
        <li>Crear el siguiente formulario:</li>
      </ul>
      <p class="text-center">
        <img src="https://gitlab.com/Material_Formacion/html-y-css/ejercicios/-/raw/master/ejercicio26/img/resultado.png?inline=false"
          height="400">
      </p>
    </section>

  </article>

  <script src='js/slides.keys.js'></script>
  <script src='js/slides.classes.js'></script>
  <script src='js/slides.state.js'></script>
  <script src='js/slides.kernel.js'></script>
  <script src='js/slides.jump.js'></script>
  <script src='js/slides.swipe.js'></script>

  <script>
    const { Deck, classes, keys, state, jump, swipe } = S6;
    const deck = new Deck({
      parent: 'article',
      plugins: [classes(), keys(), state(), jump(), swipe()]
    });
  </script>
</body>

</html>
